<template>
  <div class="">
    <h2>Account toevoegen</h2>
    <div class="bg-white m-3 p-3 border-radius drop-shadow">
      <div class="row justify-content-center">
        <form @submit.prevent="onSubmit" class="col-lg-6">
          <div class="mb-3">
            <div
              class="error-text"
              v-for="(error, index) in this.errors"
              :key="index"
            >
              {{ error }}
            </div>
          </div>
          <div class="mb-3">
            <label for="tel" class="h5 mb-1 required">Telefoonnummer</label>
            <input
              class="form-control p-2"
              required
              autocomplete="tel"
              v-model="fields.tel"
              type="tel"
            />
          </div>
          <div class="row">
            <div class="mb-3 col-6">
              <label for="firstName" class="h5 mb-1">Voornaam</label>
              <input
                class="form-control p-2"
                autocomplete="given-name"
                v-model="fields.firstName"
                type="firstName"
              />
            </div>
            <div class="mb-3 col-6">
              <label for="lastName" class="h5 mb-1">Achternaam</label>
              <input
                class="form-control p-2"
                autocomplete="family-name"
                v-model="fields.lastName"
                type="lastName"
              />
            </div>
          </div>
          <div class="form-check mb-3">
            <input
              class="form-check-input"
              type="checkbox"
              v-model="moreInfo"
              id="moreInfo"
            />
            <label class="form-check-label" for="moreInfo">
              Ik wil meer informatie toevoegen
            </label>
          </div>
          <div v-if="moreInfo">
            <div class="mb-3">
              <label for="email" class="h5 mb-1">Email</label>
              <input
                class="form-control p-2"
                autocomplete="email"
                v-model="fields.email"
                type="email"
              />
            </div>
            <div class="mb-3">
              <label for="role" class="h5 mb-1">Rol</label>
              <select
                class="form-select"
                v-model="fields.role"
                aria-label="Default select example"
                type="number"
              >
                <option selected>Selecteer een rol</option>
                <option value="2">Student</option>
                <option value="1">Super Student</option>
                <option value="0">Admin</option>
              </select>
            </div>
          </div>
          <button type="submit">Opslaan</button>
        </form>
      </div>
    </div>
  </div>
</template>

<script>
import axios from "axios";
export default {
  data() {
    return {
      submitting: false,
      fields: {},
      moreInfo: false,
      errors: [],
      hasErrors: false,
    };
  },
  methods: {
    onSubmit() {
      this.validatePhoneNumber(this.fields.tel);
      if (!this.hasErrors) {
        this.postUser();
      }
    },
    async postUser() {
      const userData = {
        firstName: this.fields.firstName,
        lastName: this.fields.lastName,
        phoneNumber: this.fields.tel,
        role: parseInt(this.fields.role) || 2,
        email: this.fields.email,
      };
      await axios.post("/api/user", userData).then((response) => {
        console.log(response);
        this.$router.push({ name: "home" });
      });
    },
    validatePhoneNumber(tel) {
      if (tel.substring(0, 3) == "+32") {
        this.errors.splice(0);
        this.hasErrors = false;
      } else {
        this.errors[0] = "phonenumber should start with +32";
        this.hasErrors = true;
      }

      if (tel.substring(3).length == 9) {
        this.errors.splice(1);
        this.hasErrors = false;
      } else {
        this.hasErrors = true;
        this.errors[1] = "phonenumber should have 9 characters";
      }
    },
  },
  mounted() {},
  computed: {
    formData() {
      const fd = new FormData();
      Object.keys(this.fields).forEach((key) => {
        fd.append(key, this.fields[key]);
      });
      return fd;
    },
  },
};
</script>
<style lang="scss" scoped>
@import "../assets/css/base.css";
@import "../assets/css/colors.css";
.error-text {
  color: red;
}
label.required:after {
  content: " *";
  color: red;
}
</style>
